{ 030301a4a.pas                                                             }
{ 2003-03-01 programmeerimisvistluse algajate 4. lesande lahendus         }
{    AKNAD                                                                  }
{ Kristo Tammeoja                                                           }
{ Testitud: FPC 1.0.6/Win32, TPC 7.0                                        }

Const
 SisFail = 'AKEN.SIS'; ValFail = 'AKEN.VAL';

 MAX_N = 100;

Type
 t_ristkylik = Record
  x1, y1, x2, y2 : LongInt;
 End;

 t_koord_mas = Array [1..2*MAX_N] of LongInt;

Var
 sfail, vfail : Text;

 {Failist loetud andmed}
 N : LongInt;
 peaaken : t_ristkylik;
 aken : Array [1..MAX_N] of t_ristkylik;

 aknaid : LongInt; {alamaknaid prast nendede likamist}

 vastus : LongInt;


 xd, yd : t_koord_mas; {erinevad x ja y koordinaadid}
 x_arv, y_arv : LongInt; {erinevate x ja y koordinaatide arv}

 {Element i, j thistab ristkylikut (normeeritud) koordinaatidega
  xd[i], yd[j], xd[i+1], yd[j+1]}
 ekraan : Array [1..2*MAX_N, 1..2*MAX_N] of Boolean;



{-------------- ABIMEETODID ----------------}


Function Max (a, b : LongInt) : LongInt;
Begin
 If a>b Then Max := a Else Max := b;
End;


Function Min (a, b : LongInt) : LongInt;
Begin
 If a<b Then Min := a Else Min := b;
End;



{-------------------------------------------}


Procedure LoeAndmed;
Var l : LongInt;
Begin
 Assign (sfail, SisFail); Reset (sfail);

 {Peaaken}
 ReadLn (sfail, peaaken.x1, peaaken.y1, peaaken.x2, peaaken.y2);

 {Alamaknad}
 ReadLn (sfail, N);
 For l := 1 To N Do
  ReadLn (sfail, aken[l].x1, aken[l].y1, aken[l].x2, aken[l].y2);

 Close (sfail);
End;



Procedure NormaliseeriKoordinaadid;
Var l : LongInt;

 Procedure Normaliseeri (var rk : t_ristkylik);
 Begin
  Inc (rk.x2); Inc (rk.y2);
 End;

Begin
 Normaliseeri (peaaken);

 For l := 1 To N Do
  Normaliseeri (aken[l]);
End;



Procedure LoikaAknaid;
Var l : LongInt;

 Procedure Loika (var rk : t_ristkylik);
 Begin
  rk.x1 := Max (rk.x1, peaaken.x1);
  rk.y1 := Max (rk.y1, peaaken.y1);
  rk.x2 := Min (rk.x2, peaaken.x2);
  rk.y2 := Min (rk.y2, peaaken.y2);
 End;

Begin
 aknaid := 0;

 For l := 1 To N Do Begin
  Loika (aken[l]);

  If (aken[l].x1<aken[l].x2) And (aken[l].y1<aken[l].y2) Then Begin
   {Kui akna pindala ji prast likamist nullist suuremaks}
   Inc (aknaid);
   aken[aknaid] := aken[l];
  End;
 End;

End;



{---------------- LAHENDAMINE ----------------}


{Sorteerib kuhja meetodil jada kasvavalt.
 Kuhjas on suuremad elemendid levalpool.}
Procedure Sorteeri (arv : LongInt; var mas : t_koord_mas);
Var a, pikkus : LongInt;

 Procedure ylesse (i : LongInt);
 Var a, j : LongInt;
 Begin
  If i = 1 Then Exit; {kui on jutud kuhja juureni}

  j := i div 2; {lemus}
  If mas[j]<mas[i] Then Begin
   a := mas[i]; mas[i] := mas[j]; mas[j] := a;
   ylesse (j);
  End;
 End;

 Procedure alla (i : LongInt);
 Var a, j, k : LongInt;
 Begin
  {leiame suurima alluva indeksi j}
  j := i;

  k := 2*i; {vasak alluv}
  If (k<=pikkus) And (mas[k]>mas[j]) Then j := k;

  Inc (k); {parem alluv}
  If (k<=pikkus) And (mas[k]>mas[j]) Then j := k;

  If j<>i Then Begin {leiti suurem alluv}
   a := mas[i]; mas[i] := mas[j]; mas[j] := a;
   alla (j);
  End;
 End;

Begin
 {Kuhja moodustamine}
 For pikkus := 2 To arv Do
  ylesse (pikkus);

 {Sorteerimine}
 For pikkus := arv-1 DownTo 1 Do Begin
  {Esimene element massiivi lppu ja kuhja viimane element esimeseks}
  a := mas[1]; mas[1] := mas[pikkus+1]; mas[pikkus+1] := a;
  alla (1);
 End;
End;



{Sorteerib ra ja leiab erinevad elemendid. Nende arv salvestatakse
 esimesse parameetrisse}
Procedure LeiaErinevad (var arv : LongInt; var mas : t_koord_mas);
Var pikkus, l : LongInt;
Begin
 If arv=0 Then Exit; {...}

 Sorteeri (arv, mas);

 {Korduvate vlja selumine}
 pikkus := 1; {esimene on kindlasti unikaalne}
 For l := 2 To arv Do
  If mas[pikkus]<>mas[l] Then Begin
   {leiti uus element}
   Inc (pikkus);
   mas[pikkus] := mas[l];
  End;

 {uue massiivi pikkuse tagastamiseks}
 arv := pikkus;
End;



Procedure TaidaKoordinaatideMassiivid;
Var l : LongInt;
Begin
 {x-d}
 For l := 1 To aknaid Do Begin
  xd[2*(l-1) + 1] := aken[l].x1;
  xd[2*(l-1) + 2] := aken[l].x2;
 End;
 x_arv := 2*aknaid; {massiivi pikkus}
 LeiaErinevad (x_arv, xd); {ttlemine}

 {y-d}
 For l := 1 To aknaid Do Begin
  yd[2*(l-1) + 1] := aken[l].y1;
  yd[2*(l-1) + 2] := aken[l].y2;
 End;
 y_arv := 2*aknaid; {massiivi pikkus}
 LeiaErinevad (y_arv, yd); {ttlemine}
End;



Procedure TyhjendaEkraan;
Var x, y : LongInt;
Begin
 For x := 1 To x_arv-1 Do
  For y := 1 To y_arv-1 Do
   ekraan[x,y] := False;
End;



{Tagastab arvu arv asukoha kasvavalt sorteeritud massiivis mas
 (pikkusega pik). Eeldatakse, et see arv leidub massiivis}
Function OtsiArv (arv : LongInt; pik : LongInt; mas : t_koord_mas) : LongInt;
Var l : LongInt;
Begin
 OtsiArv := -1;

 For l := 1 To pik Do
  If mas[l] = arv Then Begin
   OtsiArv := l;
   Exit;
  End;
End;



Procedure PaneAken (var rk : t_ristkylik);
Var x, y : LongInt; xa, ya, xl, yl : LongInt;
Begin
 xa := OtsiArv (rk.x1, x_arv, xd);
 ya := OtsiArv (rk.y1, y_arv, yd);
 xl := OtsiArv (rk.x2, x_arv, xd) - 1;
 yl := OtsiArv (rk.y2, y_arv, yd) - 1;

 For x := xa To xl Do
  For y := ya To Yl Do
   ekraan[x, y] := True;
End;



Function LeiaPindala : LongInt;
Var
 x, y : LongInt;
 pindala : LongInt;
Begin
 pindala := 0;
 For x := 1 To x_arv-1 Do
  For y := 1 To y_Arv-1 Do
   If ekraan[x, y] Then
    pindala := pindala + (xd[x+1]-xd[x])*(yd[y+1]-yd[y]);

 LeiaPindala := pindala;
End;



Function AlamakendePindala : LongInt;
Var l : LongInt;
Begin
 TaidaKoordinaatideMassiivid;

 TyhjendaEkraan;
 For l := 1 To aknaid Do
  PaneAken (aken[l]);

 AlamakendePindala := LeiaPindala;
End;



Procedure ArvutaVastus;
Begin
 vastus := (peaaken.x2-peaaken.x1)*(peaaken.y2-peaaken.y1) -
           AlamakendePindala;
End;


{---------------------------------------------}


Procedure KirjutaVastus;
Begin
 Assign (vfail, ValFail); Rewrite (vfail);
 WriteLn (vfail, vastus);
 Close (vfail);
End;



Begin
 LoeAndmed;
 NormaliseeriKoordinaadid;
 LoikaAknaid;

 ArvutaVastus;

 KirjutaVastus;
End.
