{ 030301e3.pas                                                              }
{ 2003-03-01 programmeerimisvistluse edasijudnute 3. lesande lahendus    }
{    ROBOT JA KLOTSID                                                       }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32                                                 }

{ Turbo Pascali jaoks peaks mluga veidi hoolikam olema...                  }

const
   sisf = 'ROBO.SIS';
   valf = 'ROBO.VAL';

const
   maxn = 100;                                   { maksimaalne klotside arv }
   maxt = 4 * maxn + 2;                    { maksimaalne graafi tippude arv }

type
   punkt = record
      x, y : real;
   end;
   klots = record
      c : punkt;
      a : real;
   end;
   vektor = punkt;

type
   tipp = record
      p : punkt;                              { punkt, mida see tipp esitab }
      k : real;                                      { kaugus lhtepunktist }
      u : boolean;                              { kas kaugust on uuendatud? }
   end;

var
   f : text;                                           { sisend/vljundfail }

   n : integer;                                              { klotside arv }
   kl : array [1..maxn] of klots;                             { klotsid ise }
   a, b : punkt;                                  { lhtepunkt ja sihtpunkt }

   t : integer;                                        { graafi tippude arv }
   tp : array [1..maxt] of tipp;                           { tippude andmed }
   sr : array [1..maxt, 1..maxt] of boolean;               { servade andmed }

{ leiab kahe punkti vahelise kauguse }
function kaugus (var p1, p2 : punkt) : real;
begin
   kaugus := sqrt(sqr(p1.x - p2.x) + sqr(p1.y - p2.y));
end;

{ leiab kahe vektori vektorkorrutise (pikkuse (koos mrgiga)) }
function vkorr (var v1, v2 : vektor) : real;
begin
   vkorr := v1.x * v2.y - v2.x * v1.y;
end;

{ kontrollib, kas sirgligud [a;b] ja [c;d] likuvad }
function loikuvad (var a, b, c, d : punkt) : boolean;
var v1, v2, v3 : vektor;
begin
   { kontrollime, kas sirge (a;b) ja lik [c;d] likuvad }
   v1.x := b.x - a.x; v1.y := b.y - a.y;
   v2.x := c.x - a.x; v2.y := c.y - a.y;
   v3.x := d.x - a.x; v3.y := d.y - a.y;
   if vkorr(v1, v2) * vkorr(v1, v3) >= 0 then begin
      loikuvad := false; exit;
   end;

   { kontrollime, kas lik [a;b] ja sirge (c;d) likuvad }
   v1.x := c.x - d.x; v1.y := c.y - d.y;
   v2.x := b.x - d.x; v2.y := b.y - d.y;
   v3.x := a.x - d.x; v3.y := a.y - d.y;
   if vkorr(v1, v2) * vkorr(v1, v3) >= 0 then begin
      loikuvad := false; exit;
   end;

   loikuvad := true;
end;

{ kontrollib, kas sirglik [a;b] lbib klotsi k }
function labib (var a, b : punkt; var k : klots) : boolean;
var p1, p2 : punkt;
begin
   p1.x := k.c.x; p1.y := k.c.y;
   p2.x := k.c.x + k.a; p2.y := k.c.y + k.a;

   { kui mlemad punktid on klotsist samas suunas }
   if (a.x < p1.x) and (b.x < p1.x) then begin
      labib := false; exit;
   end;
   if (a.x > p2.x) and (b.x > p2.x) then begin
      labib := false; exit;
   end;
   if (a.y < p1.y) and (b.y < p1.y) then begin
      labib := false; exit;
   end;
   if (a.y > p2.y) and (b.y > p2.y) then begin
      labib := false; exit;
   end;

   { kontrollime likumist diagonaalidega }
   if loikuvad(a, b, p1, p2) then begin
      labib := true; exit;
   end;
   p1.x := p1.x + k.a; p2.x := p2.x - k.a;
   if loikuvad(a, b, p1, p2) then begin
      labib := true; exit;
   end;

   labib := false;
end;

{ kontrollib, kas kaks punkti "nevad" ksteist }
function naevad (var p1, p2 : punkt) : boolean;
var i : integer;
begin
   for i := 1 to n do
      if labib(p1, p2, kl[i]) then begin
         naevad := false; exit;
      end;
   naevad := true;
end;

var
   i, j : integer;
   u : boolean;
   k : real;
begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do begin
      readln(f, kl[i].a, kl[i].c.x, kl[i].c.y);
      { asendame keskpunkti vasaku alumise nurgaga }
      kl[i].c.x := kl[i].c.x - 0.5 * kl[i].a;
      kl[i].c.y := kl[i].c.y - 0.5 * kl[i].a;
   end;
   readln(f, a.x, a.y);
   readln(f, b.x, b.y);
   close(f);

   { teeme graafi tipud }
   tp[1].p := a; tp[1].k := -1; tp[1].u := false;
   tp[2].p := b; tp[2].k := -1; tp[2].u := false;
   t := 2;
   for i := 1 to n do begin
      tp[t + 1].p.x := kl[i].c.x;
      tp[t + 1].p.y := kl[i].c.y;
      tp[t + 1].k := -1; tp[t + 1].u := false;
      tp[t + 2].p.x := kl[i].c.x;
      tp[t + 2].p.y := kl[i].c.y + kl[i].a;
      tp[t + 2].k := -1; tp[t + 2].u := false;
      tp[t + 3].p.x := kl[i].c.x + kl[i].a;
      tp[t + 3].p.y := kl[i].c.y + kl[i].a;
      tp[t + 3].k := -1; tp[t + 3].u := false;
      tp[t + 4].p.x := kl[i].c.x + kl[i].a;
      tp[t + 4].p.y := kl[i].c.y;
      tp[t + 4].k := -1; tp[t + 4].u := false;
      t := t + 4;
   end;

   { teeme graafi servad }
   for i := 1 to t do begin
      sr[i, i] := false;
      for j := i + 1 to t do begin
         u := naevad(tp[i].p, tp[j].p);
         sr[i, j] := u;
         sr[j, i] := u;
      end;
   end;

   { teeme primitiivse laiuti lbimise moodi asja }
   tp[1].k := 0; tp[1].u := true;
   repeat
      u := false; { veel pole htegi kaugust uuendanud }
      for i := 1 to t do
         if tp[i].u then begin
            for j := 1 to t do
               if sr[i, j] then begin
                  k := tp[i].k + kaugus(tp[i].p, tp[j].p);
                  if (tp[j].k < 0) or (tp[j].k > k) then begin
                     tp[j].k := k; tp[j].u := true;
                     u := true;
                  end;
               end;
            tp[i].u := false;
         end;
   until not u;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, tp[2].k);
   close(f);
end.
